{% macro label(obj) %}
    {% set label_text = obj.text|default(null) %}

    {# label basic #}
    {% set label_classes = ['label']|merge(obj.classes|default([])) %}

    {# label output style #}
    {% if obj.type is defined and obj.type is not empty %}
        {% set label_classes = label_classes|merge(['label-type-' ~ obj.type]) %}
    {% else %}
        {# label color #}
        {% if obj.color is defined and obj.color is not empty %}
            {% set label_classes = label_classes|merge(['label-' ~ obj.color]) %}
        {% endif %}

        {# label backgroud-color #}
        {% if obj.background is defined and obj.background is not empty %}
            {% set label_classes = label_classes|merge(['label-background-' ~ obj.background]) %}
        {% endif %}
    {% endif %}

    {# label size #}
    {% if obj.size is defined and obj.size is not empty %}
        {% set label_classes = label_classes|merge(['label-' ~ obj.size]) %}
    {% endif %}

    {# Execution #}
    {% if label_text is not null %}
        <span class="{{ label_classes|join(' ') }}">
            {% block label_icon_before %}{% endblock %}{{ label_text }}{% block label_icon_after %}{% endblock %}
        </span>
    {% endif %}
{% endmacro %}
